Bug 1811066 - [GSS](6.4.z) WELD-2612 - Possible deadlock in conversation map cleanup
Summary: [GSS](6.4.z) WELD-2612 - Possible deadlock in conversation map cleanup
Keywords:
Status: VERIFIED
Alias: None
Product: JBoss Enterprise Application Platform 6
Classification: JBoss
Component: CDI/Weld
Version: 6.4.22
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
: EAP 6.4.23
Assignee: Romain Pelisse
QA Contact: Matej Novotny
URL:
Whiteboard:
Depends On:
Blocks: eap6423-payload 1811067 1816629
TreeView+ depends on / blocked
 
Reported: 2020-03-06 14:28 UTC by Brad Maxwell
Modified: 2020-08-26 16:25 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
: 1811067 (view as bug list)
Environment:
Last Closed:
Type: Bug


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Issue Tracker JBEAP-18903 0 Major Verified [GSS](7.3.z) WELD-2612 - Possible deadlock in conversation map cleanup 2020-09-22 21:00:26 UTC
Red Hat Issue Tracker JBEAP-18904 0 Major Verified [GSS](7.2.z) WELD-2612 - Possible deadlock in conversation map cleanup 2020-09-22 21:00:30 UTC
Red Hat Issue Tracker WELD-2612 0 Major Resolved Possible deadlock in conversation map cleanup 2020-09-22 21:00:26 UTC

Description Brad Maxwell 2020-03-06 14:28:36 UTC
There was an issue with Weld 1 possibly causing a deadlock on WFLY when one thread attempts to replicate a session a another thread does the conversation context cleanup since both need a lock on a session (via getAttribute() and on a session parameter (map of all conversations over which we synchronize).

I am not sure this issue exists on newer versions of Weld (2/3) - a lot has changed in regards to underlying structure; undertow wasn't used before, session replication options changed. Weld has very similar code in these bits throughout all its versions though.

This is known to affect Weld 1.1.34.Final on WFLY for sure.
We should apply a fix to Weld branches that doesn't require us to obtain two locks to clear up conversations. Draft of that is available on my branch - https://github.com/manovotn/core/tree/convRaceConditionFix_master

Comment 4 Peter Mackay 2020-06-30 12:43:17 UTC
Verified with EAP 6.4.23.CP.CR2


Note You need to log in before you can comment on or make changes to this bug.